题目:
https://leetcode-cn.com/problems/4sum/
本题和三数之和题型一样,一个解是三元组,一个解是四元组。
题解:
排序+双指针法。先将数组进行排序,两层for循环+两个指针遍历数组,找到符合条件的四元组进行剪枝,时间复杂度:O(n^3)。
- ?i, j 为双层for循环下标
- left = j + 1,right = nums.length - 1
- 如果 nums[i] + nums[j] + nums[left] + nums[right] < target,证明结果小于target,left应该向右移动一位才能让结果增大,所以left++
- 如果 nums[i] + nums[j] + nums[left] + nums[right] >?target,证明结果大于target,right应该向左移动一位才能让结果减少,所以right--
- 如果 nums[i] + nums[j] + nums[left] + nums[right] == target,符合条件的四元组
?过程中需要对符合条件的四元组进行剪枝,剪枝的方法是跳过循环过程中重复的元素。
public List<List<Integer>> fourSum(int[] nums, int target) {
List<List<Integer>> resultList = new ArrayList<>();
// 排序
Arrays.sort(nums);
for (int i = 0; i < nums.length; i++) {
// 剪枝重复 nums[i]
if (i > 0 && nums[i] == nums[i-1]) {
continue;
}
for (int j = i+1; j < nums.length; j++) {
// 剪枝重复 nums[j]
if (j > i+1 && nums[j] == nums[j-1]) {
continue;
}
int left = j + 1;
int right = nums.length - 1;
while (left < right) {
int sum = nums[i] + nums[j] + nums[left] + nums[right];
if (sum < target) {
left++;
} else if (sum > target) {
right--;
} else {
resultList.add(Arrays.asList(nums[i], nums[j], nums[left], nums[right]));
// 剪枝重复 nums[left]
while (left < right && nums[left] == nums[left+1]) {
left++;
}
// 剪枝重复 nums[right]
while (left < right && nums[right] == nums[right-1]) {
right--;
}
// 移动指针
left++;
right--;
}
}
}
}
return resultList;
}
当然,我们也可以用哈希表来进行剪枝,具体方法如下:
- 将四元组拼接成字符串 String answerString = "" + nums[i] + nums[j]? nums[left] + nums[right]
- 用哈希表记录这个字符串是否出现过,如果没出现证明是一组新解,完成剪枝(注意:由于最开始对数组进行了排序,所以这里得到的四元组天然就是有序的)
public List<List<Integer>> fourSum(int[] nums, int target) {
Arrays.sort(nums);
Set<String> existAnswerSet = new HashSet<>();
List<List<Integer>> resultList = new ArrayList<>();
for (int i = 0; i < nums.length; i++) {
for (int j = i+1; j < nums.length; j++) {
int left = j + 1;
int right = nums.length - 1;
while (left < right) {
int sum = nums[i] + nums[j] + nums[left] + nums[right];
if (sum < target) {
left++;
} else if (sum > target) {
right--;
} else {
// 将四元组拼接为字符串
String answerString = "" + nums[i] + nums[j] + nums[left] + nums[right];
// 如果当前字符串未出现过,证明是一组新的四元组,加入结果集中
if (!existAnswerSet.contains(answerString)) {
existAnswerSet.add(answerString);
resultList.add(Arrays.asList(nums[i], nums[j], nums[left], nums[right]));
}
left++;
right--;
}
}
}
}
return resultList;
}
?
?
|